%token	PRIVATE NAME LABEL LOCAL NUMBER
%token	EQUAL SEMI OP CP OC CC COMMA
%left	PLUS MINUS
%left	TIMES DIVIDE MOD
%right	POW
%right	UMINUS
%%
formulas:   formula formulas
	|
	;
formula	:   constant
	|   function
	;
constant:   NAME EQUAL expr SEMI
	;
function:   NAME oprivate outputs inputs block
	;
oprivate:   PRIVATE
	|
	;
outputs	:   OP vars CP
	;
inputs	:   OP opvars CP
	;
opvars	:  vars
	|
	;
vars	:   var COMMA vars
	|   var
	;
var	:   NAME oplabel
	;
oplabel	:   LABEL
	|
	;
block	:   OC locals stats CC
	;
locals	:   LOCAL names SEMI
	|
	;
names	:   NAME COMMA names
	|   NAME
	;
stats	:   stat stats
	|
	;
stat	:   names EQUAL expr SEMI
	|   SEMI
	|   block
	;
expr	:   NAME
	|   NUMBER
	|   expr PLUS expr
	|   expr MINUS expr
	|   expr TIMES expr
	|   expr DIVIDE expr
	|   expr MOD expr
	|   expr POW expr
	|   MINUS expr	%prec UMINUS
	|   NAME OP oexprs CP
	;
oexprs	:   exprs
	|
	;
exprs	:   expr COMMA exprs
	|   expr
	;
