#include "formula.h"

FormInt
LoadInt (FormReader r,
	 FormInt    *o)
{
    FormInt i;

    i = (*r) (*o++);
    return (i << 8) + (*r) (*o++);
}

FormByte
LoadByte (FormReader r,
	  FormInt   *o)
{
    return (*r) (*o++);
}

FormInt
Load (FormExe	    *e,
      FormReader    r,
      FormInt	    len)
{
    FormInt	o;
    FormInt	extra;

    e->name = LoadInt (r, &o);
    e->model = LoadByte (r, &o);
    e->numVar = LoadInt (r, &o);
    e->numFunc = LoadInt (r, &o);
    e->numConst = LoadInt (r, &o);
    e->sizeCode = LoadInt (r, &o);
    e->sizeString = LoadInt (r, &o);
    extra = ((e->numVar * sizeof (FormVar)) +
	     (e->numFunc * sizeof (FormFunc)) +
	     (e->numConst * sizeof (FormNumber)) +
	     e->sizeCode +
	     e->sizeString);
    storage = FormAlloc (extra);
    if (!storage)
	return 0;
    e->storage = storage;
}

